<?php if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class Vatansms_SMS_Gateways {

	public $mobile = array();
	public $message = '';
	public $senderNumber = '';

	private $username = '';
	private $password = '';

	private static $_instance;

	public static function init() {
		if ( ! self::$_instance ) {
			self::$_instance = new self();
		}

		return self::$_instance;
	}

	public function __construct() {
		$this->username     = PWooSMS()->Options( 'sms_gateway_username' );
		$this->password     = PWooSMS()->Options( 'sms_gateway_password' );
		$this->senderNumber = PWooSMS()->Options( 'sms_gateway_sender' );
		$this->kNO 			= PWooSMS()->Options( 'sms_gateway_kno' );

	}

	public static function get_sms_gateway() {

		$gateway = array(
		
						'vatansms'      => 'vatansms.com',

	
		);

		return apply_filters( 'pwoosms_sms_gateways', $gateway );
	}

	public function vatansms() {
		
		

		

$SOAP = new SoapClient("http://www.oztekbayi.com/webservis/service.php?wsdl", array(
"trace"      => 1,
"exceptions" => 0));
			$KULLANICINO= $this->kNO; 
			$KULLANICIADI= $this->username;
			$SIFRE=$this->password;       
			$ORGINATOR=$this->senderNumber;	
			$TUR='Normal';  // Normal yada Turkce
			$ZAMAN='';  	// İleri tarih için kullanabilirsiniz 2014-04-07 10:00:00
			$ZAMANASIMI=''; // Sms ömrünü belirtir 2014-04-07 15:00:00

			$mesaj= $this->message;
			$numaralar=implode( $this->mobile, "," );; 

			$SONUC = $SOAP->TekSmsiBirdenCokNumarayaGonder($KULLANICINO,$KULLANICIADI,$SIFRE,$ORGINATOR,$numaralar,$mesaj,$ZAMAN,$ZAMANASIMI,$TUR)->TekSmsiBirdenCokNumarayaGonderResult; 
		
		
		
		if ( $SONUC == 0 ) {
			return $response = true;//success
		} else {
			$response = $SONUC;
		}

		return $response;
	}



}